﻿using System;
using System.Text;
using System.Net.Http;
using System.Net.Http.Headers;
using System.IO;
using System.Diagnostics;

namespace FeatureGuideCharp
{
    class CreatePackageFromTemplateREST2
    {
        public static void Execute()
        {
            String API_KEY = "your api key";
            String API_URL = "https://sandbox.esignlive.com/api";
            string templateId = "5bDoPbSxrXRJFWa6ZHkSSQzAHac=";

            StringBuilder sb = new StringBuilder();

            sb.AppendLine("	{");
            sb.AppendLine(" \"name\":\"Package created from template through REST API\",");
            sb.AppendLine(" \"status\" : \"DRAFT\",");
            sb.AppendLine(" \"roles\": [");
            sb.AppendLine("   {");
            sb.AppendLine("     \"id\": \"be7452c8-3c1e-44c1-af60-17a4fa6180a4\",");
            sb.AppendLine("    \"type\": \"SIGNER\",");
            sb.AppendLine("    \"signers\": [");
            sb.AppendLine("      {");
            sb.AppendLine("       \"id\": \"sender\",");
            sb.AppendLine("        \"firstName\": \"1.firstname\",");
            sb.AppendLine("       \"lastName\": \"1.lastname\",");
            sb.AppendLine("       \"email\": \"sender@mailinator.com\"");
            sb.AppendLine("     }");
            sb.AppendLine("   ],");
            sb.AppendLine("   \"name\": \"sender\"");
            sb.AppendLine(" },");
            sb.AppendLine("  {");
            sb.AppendLine("   \"id\": \"46e1b44e-0b55-418e-bf82-d586c68a2c8c\",");
            sb.AppendLine("  \"type\": \"SIGNER\",");
            sb.AppendLine("  \"signers\": [");
            sb.AppendLine("    {");
            sb.AppendLine("      \"id\": \"signer\",");
            sb.AppendLine("      \"firstName\": \"2.firstname\",");
            sb.AppendLine("      \"lastName\": \"2.lastname\",");
            sb.AppendLine("      \"email\": \"signer@mailinator.com\"");
            sb.AppendLine("    }");
            sb.AppendLine("  ],");
            sb.AppendLine("   \"name\": \"signer\"");
            sb.AppendLine(" }");
            sb.AppendLine("  ],");
            sb.AppendLine("  \"documents\":[");

            //you can use loop here
            sb.AppendLine("      {\"id\":\"d3746a17e309f0bdac146b50d24c597ab56713dc072b2d9b\"},");
            sb.AppendLine("   {\"id\":\"77c4c90d9e3ca66d12449c9bb0bc0d818df5d2e1619d19d5\"}");
            //

            sb.AppendLine("   ]");
            sb.AppendLine("} ");
          

            StringContent jsonContent = new StringContent(sb.ToString(), Encoding.UTF8, "application/json");
            

            HttpClient httpClient = new HttpClient();
            httpClient.DefaultRequestHeaders.Authorization = new AuthenticationHeaderValue("Basic", API_KEY);
            httpClient.DefaultRequestHeaders.Add("Accept", "application/json");

            var response = httpClient.PostAsync(new Uri(API_URL) + "/packages/" + templateId + "/clone", jsonContent).Result;
           // Common.WriteToDebug("Package Id: " + response.Content.ReadAsStringAsync().Result);


            //Debugger.Log(1, "Debug", response.Content.ReadAsStringAsync().Result + "\n");



        }
    }
}
